//+------------------------------------------------------------------+
//|                                            MTF_MovingAverage.mq4 |
//|                                      
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "RK"
#property link      "http://www.forex-tsd.com"
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 SpringGreen //Yellow //Blue
#property indicator_color2 Crimson //Yellow //Red
#property indicator_width1 2
#property indicator_width2 2

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=0;
extern int MAPeriod=5;
extern int ma_shift=0;
extern int ma_method=1;    // 1 Expo,  2 Smoothed moving average,
extern int applied_price=0;
extern int MAPeriod1=12;
extern int ma_shift1=0;
extern int ma_method1=1;   //1 Expo, 2 Smoothed moving average,
extern int applied_price1=0;

extern bool   alertsOn          = true;
extern bool   alertsOnCurrent   = False;
//extern double alertsLevel       = 5;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = True;
extern bool   alertsEmail       = false;

extern bool   ShowArrows       = true;
extern string ArrowsIdentifier = "Heatmap";
extern color  ArrowUpColor     = Green;
extern color  ArrowDownColor   = Red;
extern bool   Interpolate      = true;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double trend[];


datetime prevtime = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
   string short_name1;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);          //STYLE_DOT,1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);         //,STYLE_DOT,1);
   SetIndexBuffer(2,trend);
   
   if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(0,ma_shift*TimeFrame/Period());
   SetIndexShift(1,ma_shift1*TimeFrame/Period());


//---- name for DataWindow and indicator subwindow label   
   switch(ma_method)
     {
      case 1 : short_name="MaF-EMA("; break;
      case 2 : short_name="MaF-SM("; break;
      case 3 : short_name="MaF-LW("; break;
      default : short_name="MaF-S(";
     }
   //---- name for DataWindow and indicator subwindow label   
   switch(ma_method1)
     {
      case 1 : short_name1="MaS-EMA("; break;
      case 2 : short_name1="MaS-SM("; break;
      case 3 : short_name1="MaS-LW("; break;
      default : short_name1="MaS-S(";
     }
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName (short_name+MAPeriod+") "+TimeFrameStr);  
   //IndicatorShortName (short_name1+MAPeriod1+") "+TimeFrameStr);
   SetIndexLabel (0,"HM-MAFast");
   SetIndexLabel (1,"HM-MASlow");
   SetIndexLabel (2,"HM-trend");
  
  }
//----
   return(0);
int deinit()
{
   if (ShowArrows)
   {
      int compareLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i);
            if (StringSubstr(name,0,compareLength) == ArrowsIdentifier)
                ObjectDelete(name);  
      }
   }
   return(0);
} 
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
  int start() 
 {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   double avg;
   for(int x=limit; x>=0; x--)
   //for(int x=0; x<limit; x++) 
   {  
    ExtMapBuffer1[x]=iMA(NULL,TimeFrame,MAPeriod,0,ma_method,applied_price,x) ; 
    ExtMapBuffer2[x]=iMA(NULL,TimeFrame,MAPeriod1,0,ma_method1,applied_price1,x) ;
   
    if (alertsOnCurrent)
          int whichBar = 0;
      else     whichBar = 1;   
   
    trend[x] = trend[x+1];
       if (ExtMapBuffer1[x+whichBar ] > ExtMapBuffer2[x+whichBar])  trend[x] =  1;
       if (ExtMapBuffer1[x+whichBar] < ExtMapBuffer2[x+whichBar])  trend[x] = -1;   
   }  
     
//  
  manageArrow(x);  
  manageAlerts(); 
   return(0);
 }

 void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      if ((ExtMapBuffer1[whichBar] > ExtMapBuffer2[whichBar]) 
      //&&  (Close[whichBar] > SpanA_Buffer[whichBar])
      && (prevtime != Time[0]))doAlert(whichBar,"up"  ,1);
      
      if ((ExtMapBuffer1[whichBar] < ExtMapBuffer2[whichBar])
     // &&  (Close[whichBar] < SpanA_Buffer[whichBar])
      && (prevtime != Time[0]))doAlert(whichBar,"down",-1);
   
   }
}
void doAlert(int forBar, string doWhat,double value)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," tf-",(Period())," at ",
       TimeToStr(TimeLocal(),TIME_SECONDS)," Heatmap Alert "+" Bid -"+DoubleToStr(Bid, Digits)+" Ask -"+NormalizeDouble(Ask,Digits)
       +DoubleToStr(value,2)+" HeatMap Breakout---",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Ichimoku breakout "),message);
          if (alertsSound)   PlaySound("sonbitch7.mp3");
   }
}

void manageArrow(int x)
{
   if (ShowArrows)
   {
       if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      double dist = iATR(NULL,0,20,x)/2.0;
      ObjectDelete(ArrowsIdentifier+Time[0]);         
            
      //
      //
      //
      //
      //
           
      trend[x] = trend[x+1];
         if (ExtMapBuffer1[x+whichBar] > ExtMapBuffer2[x+whichBar]) trend[x] =  1;
         if (ExtMapBuffer1[x+whichBar] > ExtMapBuffer2[x+whichBar]) trend[x] = -1;
         if (trend[x] !=trend[x+1])
         {
            string name = ArrowsIdentifier+Time[x];
            if (trend[x] == 1)
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],Low[x]-dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,241);
                  ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
            }
            else
            {
               ObjectCreate(name,OBJ_ARROW,0, Time[x],High[x]+dist );
                  ObjectSet(name,OBJPROP_ARROWCODE,242);
                  ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
            }
         }
   }
}
















//-------------------------------------------















//+------------------------------------------------------------------+

